%define milterver 0.62
%define rpmrel 1

# Put `mdk' at end of release name for builds on Mandrake
%define is_mandrake %(%{__grep} '^Mandrake *[Ll]inux' /etc/redhat-release &>/dev/null && echo 1 || echo 0)
%if %{is_mandrake}
%define rpmrelease %{rpmrel}mdk
%else
%define rpmrelease %{rpmrel}
%endif

# Where to put the initscript
%{!?_initrddir: %define _initrddir /etc/rc.d/init.d}

Summary:		Sender Forgery Checker mail filter module
Name:			sfcmilter
Epoch:			1
Version:		%{milterver}
Release:		%{rpmrelease}
License:		ACME Labs Freeware License
Group:			System Environment/Daemons
Url:			http://www.acme.com/software/sfcmilter/
Source0:		http://www.acme.com/software/sfcmilter/sfcmilter-%{version}.tar.gz
Source1:		sfcmilter-RPM-HOWTO
Source2:		sfc-redhat.init
Requires:		sendmail >= 8.12
BuildRequires:		sendmail-devel >= 8.12
BuildRoot:		%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires(pre):		chkconfig >= 1.3, shadow-utils
Requires(post):		chkconfig >= 1.3
Requires(preun):	chkconfig >= 1.3, /sbin/service
Requires(postun):	/sbin/service

%description
Sfcmilter is a plug-in that checks whether the SMTP-level mail
sender is the same as the headers-level mail sender.  It is intended
to be used in conjunction with spfmilter. Spfmilter only checks the
sender address in the SMTP transaction; that's not a bug, it's
just how SPF is defined. But it does leave you open to messages
that use an honest SMTP-level address but fake the address in the
message itself. Sfcmilter closes this hole by checking that the
address in the message matches the address in the SMTP transaction.

Since spfmilter doesn't need to look at the message body, it's more
efficient to run. Therefore, you should run spfmilter first. Any
messages that spfmilter lets through then get checked by sfcmilter,
and if they are possible forgeries sfcmilter will add a header
saying "X-Sender-Check: possibly forged". Then a third layer of the
delivery process, such as bogofilter or SpamAssassin, can look for
that header and weigh it appropriately to decide if the message is
junk or not.

%prep
%setup -q
%{__cp} %{SOURCE1} %{SOURCE2} .

%build
%configure
%{__sed} -i -e 's/-o bin -g bin //' -e 's/-m 444/-m 644/' -e 's/-m 555/-m 755/' Makefile
%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}
%{__make} BINDIR=%{buildroot}%{_sbindir} MANDIR=%{buildroot}%{_mandir} install
%{__mkdir} -p %{buildroot}{%{_sysconfdir}/{sysconfig,mail},%{_initrddir}}
%{__install} -m 755 sfc-redhat.init %{buildroot}%{_initrddir}/sfcmilter
%{__install} -d -m 700 %{buildroot}%{_localstatedir}/run/sfcmilter
: > %{buildroot}%{_localstatedir}/run/sfcmilter/sfcmilter.sock
: > %{buildroot}%{_localstatedir}/run/sfcmilter.pid

%clean
%{__rm} -rf %{buildroot}

%pre
# Create user sfcmilt to run the milter
/usr/sbin/useradd -r -d /etc/mail -s /sbin/nologin \
	-c "Sender Forgery Check Milter" sfcmilt &> /dev/null || :

%post
/sbin/chkconfig --add sfcmilter || :

%preun
if [ $1 -eq 0 ]; then
	/sbin/service sfcmilter stop &> /dev/null || :
	/sbin/chkconfig --del sfcmilter || :
fi

%postun
[ $1 -gt 0 ] && /sbin/service sfcmilter condrestart &> /dev/null || :

%files
%defattr(-,root,root,0755)
%doc README sfcmilter-RPM-HOWTO
%{_sbindir}/sfcmilter
%{_mandir}/man8/sfcmilter.8*
%{_initrddir}/sfcmilter
%dir %attr(-,sfcmilt,sfcmilt) %{_localstatedir}/run/sfcmilter
%ghost %{_localstatedir}/run/sfcmilter/sfcmilter.sock
%ghost %{_localstatedir}/run/sfcmilter.pid

%changelog
* Fri Oct 21 2005 Paul Howarth <paul@city-fan.org> 1:0.62-1
- update to 0.62
- clean up spec file
- don't delete user/group accounts on package removal
- ghost the socket and pidfile rather than removing
  %{_localstatedir}/run/sfcmilter in %%post

* Mon Jan 17 2005 Paul Howarth <paul@city-fan.org> 1:0.51-2
- incorporate suggestions from Petr Krištof (petr at kristov dot cz)
  replace _var with _localstatedir macro
  replace /etc with _sysconfdir macro
  stop sfcmilter service before removal of package
  remove %{_localstatedir}/run/sfcmilter and contents after removal of package
  restart milter after package upgrade

* Wed Sep 15 2004 Paul Howarth <paul@city-fan.org> 1:0.51-1
- first RPM version
